## mongodb 2.4.8

=== debian/changelog ===
mongodb (1:2.4.8-2) unstable; urgency=low

  * Sync with Ubuntu (closes: #730203).

  [ James Page <james.page@ubuntu.com> ]
  * d/control: Enable armhf across all binary packages.
  * d/control,tests: Add DEP-8 tests.
  * d/p/0011-Use-a-signed-char-to-store-BSONType-enumerations.patch: Fixup
    build failure on ARM due to missing signed'ness of char cast.

  [ Rogério Brito <rbrito@ime.usp.br> ]
  * debian/control: Add more details to the long descriptions.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 22 Nov 2013 18:09:38 +0100

mongodb (1:2.4.8-1) unstable; urgency=low

  * New upstream release.
  * Add armhf architecture to the supported build systems.
  * Build with SSL enabled.
  * Update Standards-Version to 3.9.5 .

  [ Viktar Vauchkevich <victorenator@gmail.com> ]
  * Add systemd support (closes: #717321).

  [ James Page <james.page@ubuntu.com> ]
  * d/copyright: Add details of MongoDB AGPL+OpenSSL license exception
    to support continued use of MongoDB with SSL support enabled
    (LP: #1175028).
  * d/mongodb.conf: Add example SSL configuration options.
  * d/mongodb-server.mongodb.upstart: Add upstart configuration.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 13 Nov 2013 07:55:06 +0000

mongodb (1:2.4.6-1) unstable; urgency=low

  * New upstream release.
  * Change package priority to optional.
  * Update Standards-Version to 3.9.4 .
  * Fix typedefs FTBFS with 0009-ignore-unused-local-typedefs.patch
    (closes: #701324), thanks to James Page <james.page@ubuntu.com>
  * Fix integer comparision FTBFS with 0010-fix-integer-signs.patch
    (closes: #724100).
  * Rework packaging with short debhelper format instead of cdbs.
  * Compile with system V8 library.
  * Move packaging to Debian servers.
  * New maintainer (closes: #725854).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 24 Sep 2013 12:31:11 +0000

=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends:
 debhelper (>= 9),
 dh-systemd (>= 1.5),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libgoogle-perftools-dev [linux-amd64 linux-i386],
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libstemmer-dev,
 libssl-dev,
 libv8-dev (>= 3.12),
 python-pymongo,
 scons
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/collab-maint/mongodb.git
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/mongodb.git
Homepage: http://www.mongodb.org
XS-Testsuite: autopkgtest

Package: mongodb
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 mongodb-dev,
 mongodb-server (>= 1:2.4.1-2),
 ${misc:Depends},
 ${shlibs:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a convenience metapackage that depends on all the mongodb parts:
 the server, the clients and the development files (headers and library).

Package: mongodb-server
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 adduser,
 mongodb-clients,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself  (mongod) and the sharding
 server/load-balancer (mongos).

Package: mongodb-clients
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the standard administrative shell (mongo) and other
 utilities for administration or analysis of performance of the server.

Package: mongodb-dev
Section: libdevel
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 libboost-dev,
 ${misc:Depends}
Suggests:
 mongodb-server
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (development)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the development headers and libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_SCONS_OPTIONS :=
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

HARDENING_OPTIONS = CC="$(CC)" CFLAGS="$(CFLAGS)" \
  CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)"
COMMON_OPTIONS = --use-system-snappy --use-system-tcmalloc --use-system-pcre \
  --use-system-boost --use-system-v8 --ssl $(DEB_SCONS_OPTIONS)

DEB_SCONS_CLEAN = --directory="." $(HARDENING_OPTIONS) . --keep-going --clean \
  $(COMMON_OPTIONS)
DEB_SCONS_BUILD = --directory="." $(HARDENING_OPTIONS) all $(COMMON_OPTIONS)
DEB_SCONS_CHECK = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke \
  $(COMMON_OPTIONS)
DEB_SCONS_INSTALL = --directory="." $(HARDENING_OPTIONS) \
  --prefix=$(CURDIR)/debian/tmp/usr install --full $(COMMON_OPTIONS)

override_dh_clean:
	scons $(DEB_SCONS_CLEAN)
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/debian/tmp-test/
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/
	rm -f $(CURDIR)/failfile.smoke $(CURDIR)/smoke-last.json
	dh_clean

override_dh_auto_build:
	scons $(DEB_SCONS_BUILD)

override_dh_auto_test:
	scons $(DEB_SCONS_CHECK)

override_dh_auto_install:
	scons $(DEB_SCONS_INSTALL)

override_dh_installinit:
	dh_installinit -pmongodb-server --name=mongodb

%:
	dh $@ --parallel

.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
	override_dh_auto_install override_dh_installinit

## mongodb 2.4.9

=== src/third_party/libstemmer_c/Makefile ===
include mkinc.mak
CFLAGS=-Iinclude
all: libstemmer.o stemwords
libstemmer.o: $(snowball_sources:.c=.o)
	$(AR) -cru $@ $^
stemwords: examples/stemwords.o libstemmer.o
	$(CC) -o $@ $^
clean:
	rm -f stemwords *.o src_c/*.o runtime/*.o libstemmer/*.o

=== debian/changelog ===
mongodb (1:2.4.9-1ubuntu2) trusty; urgency=medium

  * d/p/0099-Pagesize-hacks.patch: Apply some hacks for non-4k pages.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 27 Mar 2014 01:20:08 -0600

mongodb (1:2.4.9-1ubuntu1) trusty; urgency=medium

  * Enable ppc64el build (LP: #1288633):
    - d/control: Add ppc64el to target architectures.
    - d/control: Use google-perftools on ppc64el.
    - d/p/0004-Support-ppc64el-builds.patch: Detect ppc64 as 64 bit platform.
  * Enable javascript-less arm64 build (LP: #1288634):
    - d/control: Add arm64 to target architectures, ignore libv8-dev for arm64.
    - d/p/0002-SERVER-12065-Support-ARM-and-AArch64-builds.patch: Add support
      for arm64.
    - d/p/0001-Add-option-to-disable-javascript.patch: Add option to disable
      javascript engine.
    - d/rules: Disable scripting and drop mongo binary for arm64.
  * General non-x86 enablement:
    - d/p/0005-ARM-support-for-ASM-operations-in-MongoDB.patch: dropped in
      preference to upstream accepted patch from Robie Basak:
    - d/p/0001-SERVER-12064-Atomic-operations-for-gcc-non-Intel-arc.patch: Use
      gcc provided atomic operations for non-Intel archs.
  * d/mongodb-server.mongodb.upstart: Bump nofile limit to 64000 (LP: #1283007).
  * d/control: Use google-perftools on armhf.

 -- James Page <james.page@ubuntu.com>  Thu, 06 Mar 2014 11:08:10 +0000

mongodb (1:2.4.9-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 16 Jan 2014 12:44:01 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>
 Build-Depends:
  debhelper (>= 9),
@@ -11,14 +12,14 @@
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-thread-dev,
- libgoogle-perftools-dev [linux-amd64 linux-i386],
+ libgoogle-perftools-dev [linux-amd64 linux-i386 armhf ppc64el],
  libpcap-dev,
  libpcre3-dev,
  libreadline-dev,
  libsnappy-dev,
  libstemmer-dev,
  libssl-dev,
- libv8-dev (>= 3.12),
+ libv8-dev (>= 3.12) [!arm64],
  python-pymongo,
  scons
 Standards-Version: 3.9.5
@@ -28,7 +29,7 @@
 XS-Testsuite: autopkgtest
 
 Package: mongodb
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
 Depends:
  mongodb-dev,
  mongodb-server (>= 1:2.4.1-2),
@@ -54,7 +55,7 @@
  the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
 Depends:
  adduser,
  mongodb-clients,
@@ -82,7 +83,7 @@
  server/load-balancer (mongos).
 
 Package: mongodb-clients
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -109,7 +110,7 @@
 
 Package: mongodb-dev
 Section: libdevel
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
 Depends:
  libboost-dev,
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -18,8 +18,19 @@
 
 HARDENING_OPTIONS = CC="$(CC)" CFLAGS="$(CFLAGS)" \
   CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)"
-COMMON_OPTIONS = --use-system-snappy --use-system-tcmalloc --use-system-pcre \
+COMMON_OPTIONS = --use-system-snappy --use-system-pcre \
   --use-system-boost --use-system-v8 --ssl $(DEB_SCONS_OPTIONS)
+
+gperftools_archs = amd64 i386 armhf ppc64el
+ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
+COMMON_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
+else
+COMMON_OPTIONS += --allocator=system
+endif
+
+ifeq ($(DEB_HOST_ARCH), arm64)
+COMMON_OPTIONS += --disable-scripting
+endif
 
 DEB_SCONS_CLEAN = --directory="." $(HARDENING_OPTIONS) . --keep-going --clean \
   $(COMMON_OPTIONS)
@@ -50,6 +61,14 @@
 override_dh_installinit:
 	dh_installinit -pmongodb-server --name=mongodb
 
+ifeq ($(DEB_HOST_ARCH), arm64)
+# mongo shell is broken without scripting so drop it from
+# the binary
+override_dh_install:
+	dh_install
+	rm -f $(CURDIR)/tmp/mongodb-clients/usr/bin/mongo
+endif
+
 %:
 	dh $@ --parallel

## mongodb 2.4.10

=== debian/changelog ===
mongodb (1:2.4.10-5+deb8u1) jessie; urgency=medium

  * Redact key and nonce from auth attempt logs (Closes: #833087)
  * Backport patch for CVE-2016-6494 from 2.6 (Closes: #832908)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Wed, 11 Jan 2017 11:17:56 +0200

mongodb (1:2.4.10-5) unstable; urgency=high

  * Use upstream backported fix for CVE-2015-1609 (closes: #780129).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 09 Mar 2015 21:21:24 +0000

mongodb (1:2.4.10-4) unstable; urgency=high

  * Backport potential information leak security fix from 2.4.11 .
  * Backport disable SSLv3 ciphers from pre-2.4.13 to fix CVE-2014-3566 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 10 Nov 2014 18:24:57 +0000

mongodb (1:2.4.10-3) unstable; urgency=medium

  * Enable systemd unit file (closes: #767211).
  * Update Standards-Version to 3.9.6 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 29 Oct 2014 22:43:27 +0000

mongodb (1:2.4.10-2) unstable; urgency=low

  * Enable systemd service (closes: #745674).
  * Support NUMA configurations (closes: #714955).

  [ Thomas Goirand <zigo@debian.org> ]
  * Build with -Wno-unused-function, fixing FTBFS with gcc-4.9
    (closes: #746887).

  [ Svante Signell <svante.signell@gmail.com> ]
  * Add support for GNU/Hurd (closes: #747586).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 21 Jun 2014 18:34:48 +0000

mongodb (1:2.4.10-1) unstable; urgency=low

  * New upstream release.
  * Sync with Ubuntu.

  [ James Page <james.page@ubuntu.com> ]
  * Enable ppc64el build (LP: #1288633):
    - d/control: Add ppc64el to target architectures.
    - d/control: Use google-perftools on ppc64el.
    - d/p/0004-Support-ppc64el-builds.patch: Detect ppc64 as 64 bit platform.
  * d/mongodb-server.mongodb.upstart: Bump nofile limit to 64000 (LP: #1283007).
  * d/control: Use google-perftools on armhf.

  [ Adam Conrad <adconrad@ubuntu.com> ]
  * d/p/0099-Pagesize-hacks.patch: Apply some hacks for non-4k pages.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 15 Apr 2014 13:47:02 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>
 Build-Depends:
  debhelper (>= 9),
@@ -19,17 +18,17 @@
  libsnappy-dev,
  libstemmer-dev,
  libssl-dev,
- libv8-dev (>= 3.12) [!arm64],
+ libv8-dev (>= 3.12),
  python-pymongo,
  scons
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/collab-maint/mongodb.git
 Vcs-Browser: http://anonscm.debian.org/git/collab-maint/mongodb.git
 Homepage: http://www.mongodb.org
 XS-Testsuite: autopkgtest
 
 Package: mongodb
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
 Depends:
  mongodb-dev,
  mongodb-server (>= 1:2.4.1-2),
@@ -55,7 +54,7 @@
  the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
 Depends:
  adduser,
  mongodb-clients,
@@ -83,7 +82,7 @@
  server/load-balancer (mongos).
 
 Package: mongodb-clients
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -110,7 +109,7 @@
 
 Package: mongodb-dev
 Section: libdevel
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf ppc64el arm64
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
 Depends:
  libboost-dev,
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -18,19 +18,8 @@
 
 HARDENING_OPTIONS = CC="$(CC)" CFLAGS="$(CFLAGS)" \
   CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)"
-COMMON_OPTIONS = --use-system-snappy --use-system-pcre \
+COMMON_OPTIONS = --use-system-snappy --use-system-tcmalloc --use-system-pcre \
   --use-system-boost --use-system-v8 --ssl $(DEB_SCONS_OPTIONS)
-
-gperftools_archs = amd64 i386 armhf ppc64el
-ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
-COMMON_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
-else
-COMMON_OPTIONS += --allocator=system
-endif
-
-ifeq ($(DEB_HOST_ARCH), arm64)
-COMMON_OPTIONS += --disable-scripting
-endif
 
 DEB_SCONS_CLEAN = --directory="." $(HARDENING_OPTIONS) . --keep-going --clean \
   $(COMMON_OPTIONS)
@@ -59,18 +48,11 @@
 	scons $(DEB_SCONS_INSTALL)
 
 override_dh_installinit:
+	dh_systemd_enable --name=mongodb
 	dh_installinit -pmongodb-server --name=mongodb
 
-ifeq ($(DEB_HOST_ARCH), arm64)
-# mongo shell is broken without scripting so drop it from
-# the binary
-override_dh_install:
-	dh_install
-	rm -f $(CURDIR)/tmp/mongodb-clients/usr/bin/mongo
-endif
-
 %:
-	dh $@ --parallel
+	dh $@ --parallel --with=systemd
 
 .PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
 	override_dh_auto_install override_dh_installinit

## mongodb 2.4.14

=== SConstruct ===
# -*- mode: python; -*-
# build file for MongoDB
# this requires scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

# This file, SConstruct, configures the build environment, and then delegates to
# several, subordinate SConscript files, which describe specific build rules.

import buildscripts
import datetime
import imp
import os
import re
import shutil
import stat
import sys
import types
import urllib
import urllib2
from buildscripts import utils
from buildscripts import moduleconfig

import libdeps

EnsureSConsVersion( 1, 1, 0 )
if "uname" in dir(os):
    scons_data_dir = ".scons/%s/%s" % ( os.uname()[0] , os.getenv( "HOST" , "nohost" ) )
else:
    scons_data_dir = ".scons/%s/" % os.getenv( "HOST" , "nohost" )
SConsignFile( scons_data_dir + "/sconsign" )

DEFAULT_INSTALL_DIR = "/usr/local"


def findSettingsSetup():
    sys.path.append( "." )
    sys.path.append( ".." )
    sys.path.append( "../../" )


# --- options ----

options = {}

options_topass = {}

def add_option( name, help, nargs, contributesToVariantDir,
                dest=None, default = None, type="string", choices=None ):

    if dest is None:
        dest = name

    AddOption( "--" + name , 
               dest=dest,
               type=type,
               nargs=nargs,
               action="store",
               choices=choices,
               default=default,
               help=help )

    options[name] = { "help" : help ,
                      "nargs" : nargs ,
                      "contributesToVariantDir" : contributesToVariantDir ,
                      "dest" : dest,
                      "default": default }

def get_option( name ):
    return GetOption( name )

def _has_option( name ):
    x = get_option( name )
    if x is None:
        return False

    if x == False:
        return False

    if x == "":
        return False

    return True

def has_option( name ):
    x = _has_option(name)

    if name not in options_topass:
        # if someone already set this, don't overwrite
        options_topass[name] = x

    return x

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

def get_variant_dir():
    
    a = []
    
    for name in options:
        o = options[name]
        if not has_option( o["dest"] ):
            continue
        if not o["contributesToVariantDir"]:
            continue
        if get_option(o["dest"]) == o["default"]:
            continue
        
        if o["nargs"] == 0:
            a.append( name )
        else:
            x = get_option( name )
            x = re.sub( "[:,\\\\/]" , "_" , x )
            a.append( name + "_" + x )
            
    s = "#build/${PYSYSPLATFORM}/"

    if len(a) > 0:
        a.sort()
        s += "/".join( a ) + "/"
    else:
        s += "normal/"
    return s
        
# build output
add_option( "mute" , "do not display commandlines for compiling and linking, to reduce screen noise", 0, False )

# installation/packaging
add_option( "prefix" , "installation prefix" , 1 , False, default=DEFAULT_INSTALL_DIR )
add_option( "distname" , "dist name (0.8.0)" , 1 , False )
add_option( "distmod", "additional piece for full dist name" , 1 , False )
add_option( "nostrip", "do not strip installed binaries" , 0 , False )

add_option( "sharedclient", "build a libmongoclient.so/.dll" , 0 , False )
add_option( "full", "include client and headers when doing scons install", 0 , False )

# linking options
add_option( "release" , "release build" , 0 , True )
add_option( "static" , "fully static build" , 0 , False )
add_option( "static-libstdc++" , "statically link libstdc++" , 0 , False )

# base compile flags
add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )

add_option( "cxx", "compiler to use" , 1 , True )
add_option( "cc", "compiler to use for c" , 1 , True )
add_option( "ld", "linker to use" , 1 , True )

add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , True )
add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , True )

add_option( "extrapath", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" , 1 , True )
add_option( "extrapathdyn", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" , 1 , True )
add_option( "extralib", "comma separated list of libraries  (--extralib js_static,readline" , 1 , True )

add_option( "boost-compiler", "compiler used for boost (gcc41)" , 1 , True , "boostCompiler" )
add_option( "boost-version", "boost version for linking(1_38)" , 1 , True , "boostVersion" )

add_option( "no-glibc-check" , "don't check for new versions of glibc" , 0 , False )

# experimental features
add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
add_option( "asio" , "Use Asynchronous IO (NOT READY YET)" , 0 , True )
add_option( "ssl" , "Enable SSL" , 0 , True )

# library choices
add_option( "usesm" , "use spider monkey for javascript" , 0 , True )
add_option( "usev8" , "use v8 for javascript" , 0 , True )

# mongo feature options
add_option( "noshell", "don't build shell" , 0 , True )
add_option( "safeshell", "don't let shell scripts run programs (still, don't run untrusted scripts)" , 0 , True )
add_option( "win2008plus", "use newer operating system API features" , 0 , False )

# dev options
add_option( "d", "debug build no optimization, etc..." , 0 , True , "debugBuild" )
add_option( "dd", "debug build no optimization, additional debug logging, etc..." , 0 , True , "debugBuildAndLogging" )
add_option( "durableDefaultOn" , "have durable default to on" , 0 , True )
add_option( "durableDefaultOff" , "have durable default to off" , 0 , True )

add_option( "pch" , "use precompiled headers to speed up the build (experimental)" , 0 , True , "usePCH" )
add_option( "distcc" , "use distcc for distributing builds" , 0 , False )
add_option( "clang" , "use clang++ rather than g++ (experimental)" , 0 , True )

# debugging/profiling help
if os.sys.platform.startswith("linux") and (os.uname()[-1] == 'x86_64'):
    defaultAllocator = 'tcmalloc'
elif (os.sys.platform == "darwin") and (os.uname()[-1] == 'x86_64'):
    defaultAllocator = 'tcmalloc'
else:
    defaultAllocator = 'system'
add_option( "allocator" , "allocator to use (tcmalloc or system)" , 1 , True,
            default=defaultAllocator )
add_option( "gdbserver" , "build in gdb server support" , 0 , True )
add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
add_option( "gcov" , "compile with flags for gcov" , 0 , True )

add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
add_option("smokeauth", "run smoke tests with --auth", 0 , False )

add_option("use-sasl-client", "Support SASL authentication in the client library", 0, False)

add_option( "use-system-tcmalloc", "use system version of tcmalloc library", 0, True )

add_option( "use-system-pcre", "use system version of pcre library", 0, True )

add_option( "use-system-boost", "use system version of boost libraries", 0, True )

add_option( "use-system-snappy", "use system version of snappy library", 0, True )

add_option( "use-system-sm", "use system version of spidermonkey library", 0, True )
add_option( "use-system-v8", "use system version of v8 library", 0, True )

add_option( "use-system-all" , "use all system libraries", 0 , True )

add_option( "use-cpu-profiler",
            "Link against the google-perftools profiler library",
            0, False )

add_option("mongod-concurrency-level", "Concurrency level, \"global\" or \"db\"", 1, True,
           type="choice", choices=["global", "db"])

add_option('client-dist-basename', "Name of the client source archive.", 1, False,
           default='mongo-cxx-driver')

add_option('disable-warnings-as-errors', "Don't add -Werror to compiler command line", 0, False)

# don't run configure if user calls --help
if GetOption('help'):
    Return()

# --- environment setup ---

variantDir = get_variant_dir()

def printLocalInfo():
    import sys, SCons
    print( "scons version: " + SCons.__version__ )
    print( "python version: " + " ".join( [ `i` for i in sys.version_info ] ) )

printLocalInfo()

boostLibs = [ "thread" , "filesystem" , "program_options", "system" ]

onlyServer = len( COMMAND_LINE_TARGETS ) == 0 or ( len( COMMAND_LINE_TARGETS ) == 1 and str( COMMAND_LINE_TARGETS[0] ) in [ "mongod" , "mongos" , "test" ] )
nix = False
linux = False
linux64  = False
darwin = False
windows = False
freebsd = False
openbsd = False
solaris = False
force32 = has_option( "force32" ) 
force64 = has_option( "force64" )
if not force64 and not force32 and os.getcwd().endswith( "mongo-64" ):
    force64 = True
    print( "*** assuming you want a 64-bit build b/c of directory *** " )
msarch = None
if force32:
    msarch = "x86"
elif force64:
    msarch = "amd64"

release = has_option( "release" )
static = has_option( "static" )

debugBuild = has_option( "debugBuild" ) or has_option( "debugBuildAndLogging" ) 
debugLogging = has_option( "debugBuildAndLogging" )
noshell = has_option( "noshell" ) 

usesm = has_option( "usesm" )
usev8 = has_option( "usev8" ) 

asio = has_option( "asio" )

usePCH = has_option( "usePCH" )

justClientLib = (COMMAND_LINE_TARGETS == ['mongoclient'])

env = Environment( BUILD_DIR=variantDir,
                   CLIENT_ARCHIVE='${CLIENT_DIST_BASENAME}${DIST_ARCHIVE_SUFFIX}',
                   CLIENT_DIST_BASENAME=get_option('client-dist-basename'),
                   CLIENT_LICENSE='#distsrc/client/LICENSE.txt',
                   CLIENT_SCONSTRUCT='#distsrc/client/SConstruct',
                   DIST_ARCHIVE_SUFFIX='.tgz',
                   EXTRAPATH=get_option("extrapath"),
                   MODULE_BANNERS=[],
                   MODULE_LIBDEPS_MONGOD=[],
                   MODULE_LIBDEPS_MONGOS=[],
                   MODULE_LIBDEPS_MONGOSHELL=[],
                   MODULETEST_ALIAS='moduletests',
                   MODULETEST_LIST='#build/moduletests.txt',
                   MSVS_ARCH=msarch ,
                   PYTHON=utils.find_python(),
                   SERVER_ARCHIVE='${SERVER_DIST_BASENAME}${DIST_ARCHIVE_SUFFIX}',
                   TARGET_ARCH=msarch ,
                   tools=["default", "gch", "jsheader", "mergelib", "unittest"],
                   UNITTEST_ALIAS='unittests',
                   UNITTEST_LIST='#build/unittests.txt',
                   PYSYSPLATFORM=os.sys.platform,

                   PCRE_VERSION='8.36',
                   CONFIGUREDIR = '#' + scons_data_dir + '/sconf_temp',
                   CONFIGURELOG = '#' + scons_data_dir + '/config.log'
                   )

# This could be 'if solaris', but unfortuantely that variable hasn't been set yet.
if "sunos5" == os.sys.platform:
    # SERVER-9890: On Solaris, SCons preferentially loads the sun linker tool 'sunlink' when
    # using the 'default' tools as we do above. The sunlink tool sets -G as the flag for
    # creating a shared library. But we don't want that, since we always drive our link step
    # through CC or CXX. Instead, we want to let the compiler map GCC's '-shared' flag to the
    # appropriate linker specs that it has compiled in. We could (and should in the future)
    # select an empty set of tools above and then enable them as appropriate on a per platform
    # basis. Until then the simplest solution, as discussed on the scons-users mailing list,
    # appears to be to simply explicitly run the 'gnulink' tool to overwrite the Environment
    # changes made by 'sunlink'. See the following thread for more detail:

=== debian/changelog ===
mongodb (1:2.4.14-4) unstable; urgency=low

  * Ignore self-test failure on non-Linux architectures due to filesystem
    timestamp resolution to move with Boost 1.55 removal (closes: #822130).
  * Update Standards-Version to 3.9.8 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 14 May 2016 19:27:09 +0000

mongodb (1:2.4.14-3) unstable; urgency=low

  * Fix FTBFS with newer g++ 5.2 versions (closes: #794931).
  * Build depend on newer g++ 5.2 versions (closes: #793262).
  * Build depend on GCC 5 transitioned snappy versions.
  * Remove ppc64el from the packages, it doesn't have libv8-dev .
  * Move adduser dependency to pre-depends.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 08 Aug 2015 18:57:06 +0200

mongodb (1:2.4.14-2) unstable; urgency=low

  * Fix FTBFS with gcc 5.1 (closes: #778012).
  * Update Vcs-Browser location (closes: #745341).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 04 Jul 2015 07:10:47 +0000

mongodb (1:2.4.14-1) unstable; urgency=low

  * New upstream release.
  * Remove applied patches.
  * Specify home directory when adding mongodb user.

  [ Svante Signell <svante.signell@gmail.com> ]
  * Fix build with python-pymongo 3.0+ (closes: #786823).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 31 May 2015 12:46:04 +0000

=== debian/control ===
--- 
+++ 
@@ -7,28 +7,29 @@
  debhelper (>= 9),
  dh-systemd (>= 1.5),
  libboost-date-time-dev,
- libboost-dev (>> 1.50),
+ libboost-dev (>> 1.58),
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-thread-dev,
- libgoogle-perftools-dev [linux-amd64 linux-i386 armhf ppc64el],
+ libgoogle-perftools-dev [linux-amd64 linux-i386 armhf],
  libpcap-dev,
  libpcre3-dev,
  libreadline-dev,
- libsnappy-dev,
+ libsnappy-dev (>= 1.1.3-2),
  libstemmer-dev,
  libssl-dev,
  libv8-dev (>= 3.12),
  python-pymongo,
- scons
-Standards-Version: 3.9.6
+ scons,
+ g++ (>= 4:5.2.1-2)
+Standards-Version: 3.9.8
 Vcs-Git: git://anonscm.debian.org/collab-maint/mongodb.git
-Vcs-Browser: http://anonscm.debian.org/git/collab-maint/mongodb.git
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/mongodb.git/
 Homepage: http://www.mongodb.org
 XS-Testsuite: autopkgtest
 
 Package: mongodb
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf
 Depends:
  mongodb-dev,
  mongodb-server (>= 1:2.4.1-2),
@@ -54,9 +55,10 @@
  the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf
+Pre-Depends:
+ adduser
 Depends:
- adduser,
  mongodb-clients,
  ${misc:Depends},
  ${shlibs:Depends}
@@ -82,7 +84,7 @@
  server/load-balancer (mongos).
 
 Package: mongodb-clients
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -109,7 +111,7 @@
 
 Package: mongodb-dev
 Section: libdevel
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf
 Depends:
  libboost-dev,
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -42,7 +42,11 @@
 	scons $(DEB_SCONS_BUILD)
 
 override_dh_auto_test:
+ifeq ($(DEB_BUILD_ARCH_OS), linux)
 	scons $(DEB_SCONS_CHECK)
+else
+	scons $(DEB_SCONS_CHECK) || true
+endif
 
 override_dh_auto_install:
 	scons $(DEB_SCONS_INSTALL)
